#!/usr/bin/env ruby
# Possible flags are:
#   --release     this builds module for final distribution
#   --root DIR    install the binary into this directory. If this flag is not set - the script
#                 redeploys kext to local machine and restarts it

CWD = File.dirname(__FILE__)
KEXT_DIR = '../kext/build/Distribution/'
Dir.chdir(CWD)

config = ARGV.include?('--config')
make = ARGV.include?('--make')
clean = ARGV.include?('--clean')
root_dir = ARGV.index('--root') ? ARGV[ARGV.index('--root') + 1] : nil

# Compile ino32 dynamic library and create a compatibility links for it
if config then
  unless File.exists?('Makefile') then
    Dir.mkdir(root_dir)
    archs = '-arch x86_64'
    flags = "CFLAGS='#{archs} -D_DARWIN_FEATURE_64_BIT_INODE -mmacosx-version-min=10.9' LDFLAGS='#{archs}' --disable-dependency-tracking"
#  system('aclocal') or abort
#  system('autoreconf -v --install') or abort
    system("./configure #{flags} --enable-static") or abort
  end
elsif make then
  abort("root directory #{root_dir} does not exist") if ARGV.index('--root') and not File.exists?(root_dir)
  if File.exists?('Makefile') then
    system('make -s -j3') or abort
    system("cp lib/.libs/libnxfuse.2.dylib #{root_dir}/") or abort
  end
elsif clean then
  if File.exists?('Makefile') then
    system('make distclean') or abort
  end
end

