//
//  MounterCommon.h
//  Mounter
//
//  Created by Benjamin Fleischer on 02.12.12.
//  Copyright (c) 2012-2018 Benjamin Fleischer. All rights reserved.
//

#ifndef _MOUNTERCOMMON_H
#define _MOUNTERCOMMON_H

#include "BetterAuthorizationSampleLib.h"

// Commands supported by KextLoader

// "GetVersion" returns the version of the privileged helper

#define kGetVersionCommand              "GetVersion"
#define kGetVersionResponseKeyVersion   "Version"

// "LoadKext" loads the specified kernel extension

#define kLoadKextCommand                "LoadKext"
#define	kLoadKextRightName              "io.macfuse.mounter.load-kext"
#define kLoadKextRequestKeyPath         "Path"

// "UnloadKext" unloads the specified kernel extension

#define kUnloadKextCommand              "UnloadKext"
#define	kUnloadKextRightName            "io.macfuse.mounter.unload-kext"

// "SetSysctls" sets sysctls

#define kSetSysctlsCommand              "SetSysctls"
#define kSetSysctlsRightName            "io.macfuse.mounter.set-sysctls"
#define kSetSysctlsRequestKeySysctls    "Sysctls"

// "CreateMountPath" creates the specified mount point

#define kCreateMountPathCommand         "CreateMountPath"
#define kCreateMountPathRightName       "io.macfuse.mounter.create-mountpoint"
#define kCreateMountPointRequestKeyPath "Path"
#define kCreateMountPointRequestKeyUID  "UID"
#define kCreateMountPointRequestKeyGID  "GID"

/*
 * The kMounterCommandSet is used by both the app and the helper tool to
 * communicate the set of supported commands to the BetterAuthorizationSampleLib
 * module.
 */
extern const BASCommandSpec kMounterCommandSet[];

Boolean GetSystemVersion(int *major, int *minor, int *bugfix);

#endif
