/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2011, 2016 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXDEVICE, NX protocol compression and extensions to this software      */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#ifndef Debug_H
#define Debug_H

#undef  STRING
/*
#include "Types.h"
#include "String.h"
*/
#include <stdarg.h>
#include <stdio.h>


#define DEBUG

//
// Requested log level.
//
// 0 - none
// 1 - error
// 2 - info (unused)
// 3 - debug
// 4 - trace
//

#define DEBUG_LEVEL 1

//
// Macro for debug message
//

#ifdef DEBUG

void DbgInit(const char *fname, int level);

void DbgMsg(int level, const char *fmt, ...);


  #define DBG_INIT(LOGFILE, LEVEL) DbgInit(LOGFILE, LEVEL)

  #define DBG_MSG(...) DbgMsg(3, __VA_ARGS__)

  #define DBG_ENTER(FUNC) DbgMsg(4, "-> %s()...\n", FUNC)

  #define DBG_LEAVE(FUNC) DbgMsg(4, "<- %s()...\n", FUNC)

#else

  #define DBG_INIT(LOGFILE, LEVEL)

  #define DBG_MSG(...)

  #define DBG_ENTER(FUNC)

  #define DBG_LEAVE(FUNC)

#endif

//#define FAIL(CONDITION) if(CONDITION) goto fail

#define VSFAIL(X) if ((vscode  = (X))) goto fail
#define NTFAIL(X) if ((ntstat  = (X))) goto fail
#define HRFAIL(X) if ((hresult = (X))) goto fail
#define HFAIL(X)  if ((hresult = (X))) goto fail

#define HFAILEX(X, ...) if ((hresult = (X))) {Error(__VA_ARGS__); goto fail;}

#define REGFAIL(X) if ((regCode = (X)) != ERROR_SUCCESS) goto fail

#define Error(...) {fprintf(stderr, __VA_ARGS__); DbgMsg(1, __VA_ARGS__);}

//#define FAILEX(X, ...) if (X) {Error(__VA_ARGS__); goto fail;}

#endif
