#!/bin/bash

set -e
set -x

DRIVERS_DIR=Win/prebuilt

WINDDK="/cygdrive/c/Program Files (x86)/Windows Kits/10/bin/10.0.16299.0/x86/"
INF2CAT="${WINDDK}/Inf2Cat.exe"
SIGNTOOL="${WINDDK}/signtool.exe"
SIGN_NAME="NoMachine S.a.r.l."
CER_PATH="C:\CodeSigning\VeriSign Class 3 Public Primary Certification Authority - G5.cer"
TS_APP="http://timestamp.comodoca.com/authenticode"

# Go into drivers dir.

cd ${DRIVERS_DIR}

# Windows version 5:

cd i386
"${INF2CAT}" /driver:. /os:2000,XP_X86,Server2003_X86,Vista_X86,Server2008_X86,7_X86
cd ../amd64
"${INF2CAT}" /driver:. /os:XP_X64,Server2003_X64,Vista_X64,Server2008_X64,7_X64,Server2008R2_X64

cd ../

#"${SIGNTOOL}" sign /debug /v /ac "${CER_PATH}" /s my /n "${SIGN_NAME}" /tr "${TS_APP}" \
"${SIGNTOOL}" sign /debug /v /s my /n "${SIGN_NAME}" /tr "${TS_APP}" \
              /sha1 "2328867CAD634F2ADD89B01FDA7D6E0CA53F8B42" /as /fd sha1 /td sha1 \
              i386/nxfs.cat \
              i386/nxfs.sys \
              i386/nxfs.inf \
              amd64/nxfs.cat \
              amd64/nxfs.sys \
              amd64/nxfs.inf
